//*************************************************************************************
// 	: SQ7613_startup_LVD_SWRST.c
// 汾		: V1.01
// 		: 
// ע		: 
//**************************************************************************************

/*
 * --------------------------------------------------------------------------
 *   HEADER INCLUDE DEFINITIONS
 * --------------------------------------------------------------------------
 */
#include <stdlib.h>
#include "SQ7613_SFR.h"


/*
 * --------------------------------------------------------------------------
 *   MACRO DEFINITIONS
 * --------------------------------------------------------------------------
 */
 
extern unsigned int  _BaseSP;				/*ѵָʼַһ㶨SRAMһַ*/
extern unsigned int  _RAM_Top;		    /*SRAMĵһַ*/
extern unsigned int  _RAM_End;			/*SRAMһַ*/

extern unsigned char _TDataAddr[];		/* for tiny_data initialize, defined in link command file  */
extern unsigned char _TDataOrg[];			/* for tiny_data initialize, defined in link command file  */
extern unsigned int  _TDataSize;			/* for tiny_data initialize, defined in link command file  */
extern unsigned char _NDataAddr[];		/* for near_data initialize, defined in link command file  */
extern unsigned char _NDataOrg[];			/* for near_data initialize, defined in link command file  */
extern unsigned int  _NDataSize;			/* for near_data initialize, defined in link command file  */

/*
 * --------------------------------------------------------------------------
 *   FUNCTION DECLARATIONS
 * --------------------------------------------------------------------------
 */

/*#**************************************************************************#*/

/*
 ******************************************************************************
 * NAME				:STARTUP
 *-----------------------------------------------------------------------------
 * DESCRIPTION		:Startup routine
 * PARAMETER		:-
 *
 * RETURN VALUE		:-
 *
 ******************************************************************************
 */
void STARTUP( void )
{
	unsigned int VDD_Lower_DTVT_CNT;		  // VDDڼѹ֮(Cnt Vdd Lower Than Detect Voltage)
	unsigned int i,j;
	
	CLKCR1_HIRCEN = 1;						  //  HIRC
	while(CLKCR1_HIRCRDY == 0);			  	  // ȴ HIRC 
	CLKCR0 = 0x10;					  		  // ϵͳƵʳ2   (16K/2=8KHz) 

	VDD_Lower_DTVT_CNT = 0;				  	  // VDDڼѹֵ֮Ϊ0		
//=============================================================================
//memory mapping
//=============================================================================
	DMCFG  	 = 0x50; 	//Code :0x8000~0xFFFF Map to Data: 0x8000~0xFFFF,Cһʹ0x50
	//DMCFG  = 0x40;	//Code :0x0000~0x7FFF Map to Data: 0x8000~0xFFFF
	//DMCFG  = 0x00;	//No Map

//=============================================================================
// Setting detection voltage (4.2 V   126 mV)
//=============================================================================
	
	P2OE_P0=0;							  	  // LED1(P2.0)
	for(i=0;i<1500;i++){					  // ʱһʱ
		for(j=1500;j>0;j--);
	}
	P2OE_P0=1;								  // ʹLED1(P2.0)
	for(i=0;i<1500;i++){					  // ʱһʱ
		for(j=1500;j>0;j--);
	}

		
	LVDCR_LVDCFG = 6;					  	  // üѹΪ4.2 V   126 mV		
	LVDCR_LVDEN  = 1;                	  	  // LVD
	
	
	while(1){	
		WDCDR = 0x4E;             	  		  // 룬Źʱ (ι)
		if(LVDCR_LVDF == 1 && LVDCR_LVDST == 1){
			VDD_Lower_DTVT_CNT ++;			  // ⵽LVD(VDD <  趨֮ѹ)"VDDڼѹ֮"+1
			if(VDD_Lower_DTVT_CNT >= 50){	
				break;						  // ⵽LVD(VDD <  趨֮ѹ)(50+1)Σ뿪ˏhȦ
			}
		}else{
			VDD_Lower_DTVT_CNT = 0;		  	  // ⵽LVD(VDD >= 趨֮ѹ) "VDDڼѹ֮"0
		}
		
		if(LVDCR_LVDF == 1){
			LVDCR_LVDF = 1;             	  // ⵽LVDLVDΪ1
		}		
	}

	__ASM("DI");
	LVDCR_LVDIEN 	= 1;                	  // LVD 
	IER_LVD 		= 1;                	  // LVD ж
	__ASM("EI");							  // жĴ
//=============================================================================
//initial Registers
//=============================================================================
	__WA = 0x00;
	__BC = 0x00;
	__DE = 0x00;
	__HL = 0x00;
	__IX = 0x00;
	__IY = 0x00;

//=============================================================================
//initial Setting
//=============================================================================	
	__asm("CLR (0x08).5");

//=============================================================================
//initialize stack pointer
//=============================================================================
	__asm(" LD SP,__BaseSP");	//initialize stack pointer

//=============================================================================
//clear status word
//=============================================================================
	__asm(" LD PSW,0x00");

//=============================================================================
//clear RAM
//=============================================================================
	__asm(" LD HL,__RAM_Top");
	__asm(" LD BC,__RAM_End - __RAM_Top");	
	__asm(" LD A,0x00");
	__asm("CLR_RAM:");
	__asm(" LD (HL),A");
	__asm(" INC HL");
	__asm(" DEC BC");
	__asm(" JRS F,CLR_RAM");		/* Clear the RAM */

//=============================================================================
//initialize of tiny_data section
//=============================================================================
	__asm("	LD	IX,__TDataOrg");
	__asm("	LD	IY,__TDataAddr");
	__asm("	LD	A,__TDataSize");
	__asm("	DEC	A");
	__asm("	J	T,non_t_data");
	__asm("move_t_data:");
	__asm("	LD	C,(IX)");
	__asm("	LD	(IY),C");
	__asm("	INC	IX");
	__asm("	INC	IY");
	__asm("	DEC	A");
	__asm("	J	F,move_t_data");
	__asm("non_t_data:");

//=============================================================================
//initialize of near_data section
//=============================================================================
	__asm("	LD	IX,__NDataOrg");
	__asm("	LD	IY,__NDataAddr");
	__asm("	LD	WA,__NDataSize");
	__asm("	DEC	WA");
	__asm("	J	T,non_n_data");
	__asm("move_n_data:");
	__asm("	LD	C,(IX)");
	__asm("	LD	(IY),C");
	__asm("	INC	IX");
	__asm("	INC	IY");
	__asm("	DEC	WA");
	__asm("	J	F,move_n_data");
	__asm("non_n_data:");

//=============================================================================
//  other system configuration
//=============================================================================
    //System_Config();

//=============================================================================
//	Set UnPad Pin normal output LOW to avoid leakage
//=============================================================================

// 	set Low
// 	P1.4~P1.7       0000 1111  0x0F
// 	P2.5,P2.6       1001 1111  0x9F
// 	P3.0            1111 1110  0xFE
// 	P4.0,P4.1,P4.6  1011 1100  0xBC
//	P5.0,P5.4		1110 1110  0xEE

	P1DO = P1DO & ( 0x0F ); // P1.4~P1.7 	  output low
	P2DO = P2DO & ( 0x9F ); // P2.5,P2.6 	  output low
	P3DO = P3DO & ( 0xFE ); // P3.0	  		  output low
	P4DO = P4DO & ( 0xBC ); // P4.0,P4.1,P4.6 output low
	P5DO = P5DO & ( 0xEE ); // P5.0,P5.4	  output low
//---------------------------------------------------------

// 	set Output
// 	P1.4~P1.7       1111 0000  0xF0
// 	P2.5,P2.6       0110 0000  0x60
// 	P3.0            0000 0001  0x01
// 	P4.0,P4.1,P4.6  0100 0011  0x43
//	P5.0,P5.4		0001 0001  0x11

	P1OE = P1OE | ( 0xF0 ); // P1.4~P1.7 	  output
	P2OE = P2OE | ( 0x60 ); // P2.5,P2.6 	  output
	P3OE = P3OE | ( 0x01 ); // P3.0	  		  output
	P4OE = P4OE | ( 0x43 ); // P4.0,P4.1,P4.6 output
	P5OE = P5OE | ( 0x11 ); // P5.0,P5.4	  output

//=============================================================================
//jump to main
//=============================================================================
	main();
	for (;;) {
		;
	}
}

